unit ModflowParameterClassTypes;

interface

{ModflowParameterClassTypes defines meta-classes of classes of parameters. These
 metaclasses are used in GetTypesUnit.}

uses MFPrescribedHead, MFBottom, MFDomainOut,
     MFDrain, MFEvapo, MFGenHeadBound, MFGrid, MFGridDensity, MFHydraulicCond,
     MFInactive, MFInitialHead, MFMOCInitConc, MFMOCObsWell,
     MFMOCParticleRegen, MFMOCPorosity, MFRecharge, MFRechConc, MFRiver,
     MFSpecStor, MFSpecYield, MFTop, MFWells, MFWetting,
     MFStreamUnit, MFHorFlowBarrier, MFFlowAndHeadBound, MFMODPATHUnit,
     MFZoneBud, MFModPathZone, MFGenParam, MFModPathPost, MFMOCTransSubgrid,
     MFTransmissivity, MFVcont, MFConfStorage, MFMOCImPor, MFMOCLinExch,
     MFMOCDecay, MFMOCGrowth, MFMOCImInitConc, MFMOCRetardation, MFMOCDisDecay,
     MFMOCSorbDecay, MFMOCDisGrowth, MFMOCSorbGrowth, MFMultiplierUnit,
     MFZoneUnit, MFAnisotropy, MFHeadObservations, MFFluxObservationUnit,
     MFAdvectObservUnit, MFLakes, MFInterbedUnit, MFReservoir, MFSegEvap,
     MFDrainReturn, MF_HYDMOD_Unit, MFCHD, MF_HUF, MF_MNW, MF_DAFLOW,
     MF_HUF_RefSurf, MFSubsidence, MFDensity, MFMOCInitialParticles,
     MF_GWT_CBDY, MF_GWM_Flux, MF_GWM_HeadConstraint, MF_GWM_DrawdownConstraint,
     MF_GWM_HeadDifference, MF_GWM_Gradient, MF_GWM_StreamFlow,
     MF_GWM_StreamDepletion, MFMOC_ParticleObservations, MFUnsaturatedZoneFlow,
     MF_SWT, MfMt3dConcentrationObservationUnit, MF_SW_Viscosity, MF_MNW2,
  MF_GWM_StateVariables;

type
  TMFBottomElevParamClass = class of TBottomElevParam;
  TMFDomDensityParamClass = class of TDomDensityParam;
  TMFDrainElevationParamClass = class of TDrainElevationParam;
  TMFDrainOnParamClass = class of TDrainOnParam;
  TMFETSurfaceParamClass = class of TETSurface;
  TMFETExtDepthParamClass = class of TETExtDepth;
  TMFETExtFluxParamClass = class of TETExtFlux;
  TMFFHBPointAreaHeadParamClass = class of TFHBPointAreaHeadParam;
  TMFFHBPointFluxParamClass = class of TFHBPointFluxParam;
  TMFFHBTopElevParamClass = class of TFHBTopElevParam;
  TMFFHBBotElevParamClass = class of TFHBBotElevParam;
  TMFHBHeadConcParamClass = class of TFHBHeadConcParam;
  TMFHBFluxConcParamClass = class of TFHBFluxConcParam;
  TMFHBLineHeadStartParamClass = class of TFHBLineHeadStartParam;
  TMFHBLineHeadEndParamClass = class of TFHBLineHeadEndParam;
  TMFHBLineFluxParamClass = class of TFHBLineFluxParam;
  TMFHBAreaFluxParamClass = class of TFHBAreaFluxParam;
  TMFGHBHeadParamClass = class of TGHBHeadParam;
  TMFConcentrationParamClass = class of TConcentration;
  TMFConductanceParamClass = class of TConductance;
  TMFIFACEParamClass = class of TIFACEParam;
  TMFGridETSurfParamClass = class of TGridETSurf;
  TMFGridETExtinctionDepthParamClass = class of TGridETExtinctionDepth;
  TMFGridRechElevParamClass = class of TGridRechElev;
  TMFIBoundGridParamClass = class of TIBoundGridParam;
  TMFGridTopElevParamClass = class of TGridTopElev;
  TMFGridBottomElevParamClass = class of TGridBottomElev;
  TMFGridThicknessParamClass = class of TGridThickness;
  TMFGridInitialHeadParamClass = class of TGridInitialHead;
  TMFGridKxParamClass = class of TGridKx;
  TMFGridKzParamClass = class of TGridKz;
  TMFGridSpecYieldParamClass = class of TGridSpecYield;
  TMFGridSpecStorParamClass = class of TGridSpecStor;
  TMFGridWettingParamClass = class of TGridWetting;
  TMFGridWellParamClass = class of TGridWell;
  TMFGridRiverParamClass = class of TGridRiver;
  TMFGridDrainParamClass = class of TGridDrain;
  TMFGridGHBParamClass = class of TGridGHB;
  TMFGridFHBParamClass = class of TGridFHB;
  TMGridHFBParamClass = class of TGridHFB;
  TMFGridStreamParamClass = class of TGridStream;
  TMFGridMOCInitConcParamClass = class of TGridMOCInitConc;
  TMFGridMOCSubGridParamClass = class of TGridMOCSubGrid;
  TMFGridMOCParticleRegenParamClass = class of TGridMOCParticleRegen;
  TMFGridMOCPorosityParamClass = class of TGridMOCPorosity;
  TMFGridZoneBudgetParamClass = class of TGridZoneBudget;
  TMFGridModpathZoneParamClass = class of TGridModpathZone;
  TMFDensityParamClass = class of TDensityParam;
  TMFHFBHydCondParamClass = class of THFBHydCondParam;
  TMFHFBBarrierThickParamClass = class of THFBBarrierThickParam;
  TMFKxParamClass = class of TKx;
  TMFKzParamClass = class of TKz;
  TMFInactiveParamClass = class of TInactiveParam;
  TMFInitialHeadParamClass = class of TInitialHeadParam;
  TMFMOCInitialConcParamClass = class of TMOCInitialConcParam;
  TMFMOCObsElevParamClass = class of TMOCObsElev;
  TMFMOCParticleRegenParamClass = class of TMOCParticleRegenParam;
  TMFMOCPorosityParamClass = class of TMOCPorosityParam;
{  TMFModpathTime1ParamClass = class of TModpathTime1Param;
  TMFModpathTime2ParamClass = class of TModpathTime2Param;
  TMFModpathTime3ParamClass = class of TModpathTime3Param;
  TMFModpathTime4ParamClass = class of TModpathTime4Param;
  TMFModpathTime5ParamClass = class of TModpathTime5Param; }
  TMFModpathZoneParamClass = class of TModpathZoneParam;
  TMFPrescribedHeadParamClass = class of TPrescribedHeadParam;
  TMFRechElevParamClass = class of TRechElevParam;
  TMFRechStressParamClass = class of TRechStressParam;
  TMFRechConcParamClass = class of TRechConcParam;
  TMFRiverBottomParamClass = class of TRiverBottomParam;
  TMFRiverStageParamClass = class of TRiverStageParam;
  TMFSpecStorageParamClass = class of TSpecStorageParam;
  TMFSpecYieldParamClass = class of TSpecYieldParam;
  TMFStreamSegNumParamClass = class of TStreamSegNum;
  TMFStreamDownSegNumParamClass = class of TStreamDownSegNum;
  TMFStreamDivSegNumParamClass = class of TStreamDivSegNum;
  TMFStreamHydCondParamClass = class of TStreamHydCondParam;
  TMFStreamFlowParamClass = class of TStreamFlow;
  TMFStreamUpStageParamClass = class of TStreamUpStage;
  TMFStreamDownStageParamClass = class of TStreamDownStage;
  TMFStreamUpBotElevParamClass = class of TStreamUpBotElev;
  TMFStreamDownBotElevParamClass = class of TStreamDownBotElev;
  TMFStreamUpTopElevParamClass = class of TStreamUpTopElev;
  TMFStreamDownTopElevParamClass = class of TStreamDownTopElev;
  TMFStreamUpWidthParamClass = class of TStreamUpWidthParam;
  TMFStreamDownWidthParamClass = class of TStreamDownWidthParam;
  TMFStreamSlopeParamClass = class of TStreamSlope;
  TMFStreamRoughParamClass = class of TStreamRough;
  TMFTopElevParamClass = class of TTopElevParam;
  TMFWellTopParamClass = class of TWellTopParam;
  TMFWellBottomParamClass = class of TWellBottomParam;
  TMFWellStressParamClass = class of TWellStressParam;
  TMFWettingThreshParamClass = class of TWettingThreshParam;
  TMFWettingFlagParamClass = class of TWettingFlagParam;
  TMFZoneBudZoneParamClass = class of TZoneBudZone;
  TMFMODPATH_XCountParamClass = class of TMODPATH_XCount_Param;
  TMFMODPATH_YCountParamClass = class of TMODPATH_YCount_Param;
  TMFMODPATH_ZCountParamClass = class of TMODPATH_ZCount_Param;
  TMFMODPATH_ReleaseTimeParamClass = class of TMODPATH_ReleaseTimeParam;
  TMFMODPATHPartIfaceParamClass = class of TMODPATHPartIface;
  TMFMODPATH_FirstLayerParamClass = class of TMODPATH_FirstLayerParam;
  TMFMODPATH_FirstTimeParamClass = class of TMODPATH_FirstTimeParam;
  TMFMODPATH_LastLayerParamClass = class of TMODPATH_LastLayerParam;
  TMFMODPATH_LastTimeParamClass = class of TMODPATH_LastTimeParam;
  TMFMOCTransSubGridParamClass = class of TMOCTransSubGridParam;
  TMFTransmisivityParamClass = class of TTransmisivityParam;
  TMFVcontParamClass = class of TVcontParam;
  TMFConfStorageParamClass = class of TConfStorageParam;
  TMFGridVContParamClass = class of TGridVCont;
  TMFGridConfStoreParamClass = class of TGridConfStor;
  TMFGridTransParamClass = class of TGridTrans;
  TMFModflowLayerParamClass = class of TModflowLayerParam;
  TMFGridRechLayerParamClass = class of TGridRechLayerParam;
  TMFGridETLayerParamClass = class of TGridETLayerParam;
  TMFMOCImPorosityParamClass = class of TMOCImPorosityParam;
  TMFMOCLinExchCoefParamClass = class of TMOCLinExchCoefParam;
  TMFMOCDecayCoefParamClass = class of TMOCDecayCoefParam;
  TMFMOCGrowthParamClass = class of TMOCGrowthParam;
  TMFMOCImInitConcParamClass = class of TMOCImInitConcParam;
  TMFMOCRetardationParamClass = class of TMOCRetardationParam;
  TMFMOCDisDecayCoefParamClass = class of TMOCDisDecayCoefParam;
  TMFMOCSorbDecayCoefParamClass = class of TMOCSorbDecayCoefParam;
  TMFMOCDisGrowthParamClass = class of TMOCDisGrowthParam;
  TMFMOCSorbGrowthParamClass = class of TMOCSorbGrowthParam;
  TMFMODPATH_StartingZoneParamClass = class of TMODPATH_StartingZoneParam;
  TMFMODPATH_EndingZoneParamClass = class of TMODPATH_EndingZoneParam;
  TMFGridMOCPrescribedConcParamClass = class of TGridMOCPrescribedConcParam;
  TMFMultiplierParamClass = class of TMultiplierParam;
  TMFZoneParamClass = class of TZoneParam;
  TMFGridMultiplierParamClass = class of TGridMultiplier;
  TMFGridZoneParamClass = class of TGridZone;
  TMFModflowParameterNameParamClass = class of TModflowParameterNameParam;
  TMFIsParameterParamClass = class of TIsParameterParam;
  TMFAnistropyParamClass = class of TAnistropyParam;
  TMFGridAnisoParamClass = class of TGridAniso;
  TMFOnOffParamClass = class of TOnOffParam;
  TMFTotalWellStressParamClass = class of TTotalWellStressParam;
  TMFWellStressIndicatorParamClass = class of TWellStressIndicatorParam;
  TMFFHBPointBoundaryTypeParamClass = class of TFHBPointBoundaryTypeParam;
  TMFFHBLineBoundaryTypeParamClass = class of TFHBLineBoundaryTypeParam;
  TMFFHBAreaBoundaryTypeParamClass = class of TFHBAreaBoundaryTypeParam;
  TMFFHBEndHeadUsedParamClass = class of TFHBEndHeadUsedParam;
  TMFTopObsElevParamClass = class of TTopObsElevParam;
  TMFBottomObsElevParamClass = class of TBottomObsElevParam;
  TMFObservationNameParamClass = class of TObservationNameParam;
  TMFStatisticParamClass = class of TStatisticParam;
  TMFStatFlagParamClass = class of TStatFlagParam;
  TMFPlotSymbolParamClass = class of TPlotSymbolParam;
  TMFTopLayerParamClass = class of TTopLayerParam;
  TMFBottomLayerParamClass = class of TBottomLayerParam;
  TMFTimeParamClass = class of TTimeParam;
  TMFIttParamClass = class of TIttParam;
  TMFObservedHeadParamClass = class of TObservedHeadParam;
  TMFStathParamClass = class of TStathParam;
  TMFStatddParamClass = class of TStatddParam;
  TMFWeightParamClass = class of TWeightParam;
  TMFFactorParamClass = class of TFactorParam;
  TMFLossParamClass = class of TLossParam;
  TMFObservationNumberParamClass = class of TObservationNumberParam;
  TMFObservationGroupNumberParamClass = class of TObservationGroupNumberParam;
  TMFAdvObsElevParamClass = class of TAdvObsElevParam;
  TMFAdvObsGroupNumberParamClass = class of TAdvObsGroupNumberParam;
  TMFAdvObsLayerParamClass = class of TAdvObsLayerParam;
  TMFAdvObsNameParamClass = class of TAdvObsNameParam;
  TMFAdvObsXStatisticParamClass = class of TXStatisticParam;
  TMFAdvObsYStatisticParamClass = class of TYStatisticParam;
  TMFAdvObsZStatisticParamClass = class of TZStatisticParam;
  TMFAdvObsXStatFlagParamClass = class of TXStatFlagParam;
  TMFAdvObsYStatFlagParamClass = class of TYStatFlagParam;
  TMFAdvObsZStatFlagParamClass = class of TZStatFlagParam;

  TMFLakeNumberParamClass = class of TLakeNumberParam;
  TMFGageParamClass = class of TGageParam;
  TMFLakeHydraulicCondParamClass = class of TLakeHydraulicCondParam;
  TMFLakeThicknessParamClass = class of TLakeThicknessParam;
  TMFLakeInitialStageParamClass = class of TLakeInitialStageParam;
  TMFLakeMinimumStageParamClass = class of TLakeMinimumStageParam;
  TMFLakeMaximumStageParamClass = class of TLakeMaximumStageParam;
  TMFLakeInitialConcParamClass = class of TLakeInitialConcParam;
  TMFCenterLakeParamClass = class of TCenterLakeParam;
  TMFLakeSillParamClass = class of TLakeSillParam;
  TMFLakePrecipParamClass = class of TLakePrecipParam;
  TMFLakeEvapParamClass = class of TLakeEvapParam;
  TMFLakeRunoffParamClass = class of TLakeRunoffParam;
  TMFLakeWithdrawalsParamClass = class of TLakeWithdrawalsParam;
  TMFLakePrecipConcParamClass = class of TLakePrecipConcParam;
  TMFLakeRunoffConcParamClass = class of TLakeRunoffConcParam;
  TMFLakeAugmentationConcParamClass = class of TLakeAugmentationConcParam;
  TMFGridLakeLocationParamClass = class of TGridLakeLocation;
  TMFLakeBottomElevParamClass = class of TLakeBottomElevParam;
  TMFLakeBottomParamClass = class of TLakeBottomParam;
  TMFPreconsolidationHeadParamClass = class of TPreconsolidationHeadParam;
  TMFElasticStorageFactorParamClass = class of TElasticStorageFactorParam;
  TMFInelasticStorageFactorParamClass = class of TInelasticStorageFactorParam;
  TMFStartingCompactionParamClass = class of TStartingCompactionParam;
  TMFGridIbsPreconsolidationHeadParamClass = class of TGridIbsPreconsolidationHead;
  TMFGridIbsElasticStorageParamClass = class of TGridIbsElasticStorage;
  TMFGridIbsInelasticStorageParamClass = class of TGridIbsInelasticStorage;
  TMFGridIbsStartingCompactionParamClass = class of TGridIbsStartingCompaction;
  TMFReservoirLandSurfaceParamClass = class of TReservoirLandSurfaceParam;
  TMFReservoirKzParamClass = class of TReservoirKzParam;
  TMFReservoirBedThicknessParamClass = class of TReservoirBedThicknessParam;
  TMFReservoirStartingStageParamClass = class of TReservoirStartingStageParam;
  TMFReservoirEndingStageParamClass = class of TReservoirEndingStageParam;
  TMFMODPATH_StartingRowParamClass = class of TMODPATH_StartingRowParam;
  TMFMODPATH_StartingColumnParamClass = class of TMODPATH_StartingColumnParam;
  TMFGridResElevParamClass = class of TGridResElev;
  TMFGridResKzParamClass = class of TGridResKz;
  TMFGridResThicknessParamClass = class of TGridResThickness;
  TMFIsObservationParamClass = class of TIsObservationParam;
  TMFIsPredictionParamClass = class of TIsPredictionParam;
  TMFMOC_IsObservationParamClass = class of TMOC_IsObservation;
  TMF2KUpstreamKParamClass = class of TMF2KUpstreamK;
  TMF2KDownstreamKParamClass = class of TMF2KDownstreamK;
  TMF2KStreamPriorityParamClass = class of TMF2KStreamPriority;
  TMF2KUpsteamDepthParamClass = class of TMF2KUpsteamDepth;
  TMF2KDownstreamDepthParamClass = class of TMF2KDownstreamDepth;
  TMF2KStreamDownWidthParamClass = class of TMF2KStreamDownWidthParam;
  TMF2KChanelRoughnessParamClass = class of TMF2KChanelRoughnessParam;
  TMF2KBankRoughnessParamClass = class of TMF2KBankRoughnessParam;
  TMF2KPrecipitationParamClass = class of TMF2KPrecipitationParam;
  TMF2KDownstreamTopElevationParamClass = class of TMF2KDownstreamTopElevationParam;
  TMF2KUpstreamBedThicknessParamClass = class of TMF2KUpstreamBedThicknessParam;
  TMF2KDownstreamBedThicknessParamClass = class of TMF2KDownstreamBedThicknessParam;
  TMF2KCrossSectionXParamClass = class of TMF2KCrossSectionXParam;
  TMF2KCrossSectionZParamClass = class of TMF2KCrossSectionZParam;
  TMF2KTableWidthParamClass = class of TMF2KTableWidthParam;
  TMF2KTableDepthParamClass = class of TMF2KTableDepthParam;
  TMF2KTableFlowParamClass = class of TMF2KTableFlowParam;
  TMF2KWidthExponentParamClass = class of TMF2KWidthExponentParam;
  TMF2KDepthExponentParamClass = class of TMF2KDepthExponentParam;
  TMF2KWidthCoefficientParamClass = class of TMF2KWidthCoefficientParam;
  TMF2KDepthCoefficientParamClass = class of TMF2KDepthCoefficientParam;
  TMF2K_ICALC_ParamClass = class of TMF2K_ICALC_Param;
  TMF2KFlowConcentrationParamClass = class of TFlowConcentration;
  TMF2KRunoffConcentrationParamClass = class of TRunoffConcentration;
  TMF2KPrecipitationConcentrationParamClass = class of TPrecipitationConcentration;
  TMF2KRunoffParamClass = class of TMF2KRunoffParam;
  TMF2KStreamEvapParamClass = class of TMF2KStreamEvap;
  TMFGridSFRParamClass = class of TGridSFR;
  TMF2KStreamDivSegNumParamClass = class of TMF2KStreamDivSegNum;
  TMF2KStreamUpTopElevParamClass = class of TMF2KStreamUpTopElev;
  TAdjustForAngleParamClass = class of TAdjustForAngle;

  TSegETSurfaceParamClass = class of TSegETSurface;
  TSegETExtDepthParamClass = class of TSegETExtDepth;
  TSegET_MaxFluxParamClass = class of TSegET_MaxFlux;
  TSegET_IntermediateDepthParamClass = class of TSegET_IntermediateDepth;
  TSegET_IntermediateProportionParamClass = class of TSegET_IntermediateProportion;
  TGridETS_SurfaceParamClass = class of TGridETS_Surface;
  TGridETS_ExtinctDepthParamClass = class of TGridETS_ExtinctDepth;
  TGridETS_LayerParamClass = class of TGridETS_Layer;
  TDrainReturnIndexParamClass = class of TDrainReturnIndexParam;
  TDrainReturnFractionParamClass = class of TDrainReturnFractionParam;
  TGridDrainReturnParamClass = class of TGridDrainReturn;
  TMFHydmodHeadObservationParamClass = class of THydmodHeadObservationParam;
  TMFHydmodDrawDownObservationParamClass = class of THydmodDrawDownObservationParam;
  TMFHydmodPreconsolidationObservationParamClass = class of THydmodPreconsolidationObservationParam;
  TMFHydmodCompactionObservationParamClass = class of THydmodCompactionObservationParam;
  TMFHydmodSubsidenceObservationParamClass = class of THydmodSubsidenceObservationParam;
  TMFHydmodStreamStageObservationParamClass = class of THydmodStreamStageObservationParam;
  TMFHydmodStreamFlowInObservationParamClass = class of THydmodStreamFlowInObservationParam;
  TMFHydmodStreamFlowOutObservationParamClass = class of THydmodStreamFlowOutObservationParam;
  TMFHydmodStreamFlowIntoAquiferObservationParamClass = class of THydmodStreamFlowIntoAquiferObservationParam;
  TMFHydmodInterpolateParamClass = class of THydmodInterpolateParam;
  TMFHydmodLabelParamClass = class of THydmodLabelParam;
  TMFHydmodElevParamClass = class of THydmodElevParam;
  TMFHydmodModflowLayerParamClass = class of THydmodModflowLayerParam;
  TMFCHD_ElevationParamClass = class of TCHD_ElevationParam;
  TMFCHD_StartHeadParamClass = class of TCHD_StartHeadParam;
  TMFHFBLongDispParamClass = class of THFBLongDispParam;
  TMFHFBHorzTransDispParamClass = class of THFBHorzTransDispParam;
  TMFHFBVertTransDispParamClass = class of THFBVertTransDispParam;
  TMFHFBDiffusionCoefParamClass = class of THFBDiffusionCoefParam;
  TMFGridCHDParamClass = class of TGridCHD;
  TMFCHD_EndHeadParamClass = class of TCHD_EndHeadParam;
  TMFXObsNumberParamClass = class of TXObsNumber;
  TMFYObsNumberParamClass = class of TYObsNumber;
  TMFZObsNumberParamClass = class of TZObsNumber;
  TMFHUFTopParamClass = class of THUFTopParameter;
  TMFHUFThicknessParamClass = class of THUFThicknessParameter;
  TMFElevationParamClass = class of TElevationParam;
  TMFGageOutputTypeParamClass = class of TGageOutputTypeParam;
  TMFMODPATH_StartXParamClass = class of TMODPATH_StartX;
  TMFMODPATH_StartYParamClass = class of TMODPATH_StartY;
  TMFMODPATH_StartZParamClass = class of TMODPATH_StartZ;
  TMFMODPATH_EndXParamClass = class of TMODPATH_EndX;
  TMFMODPATH_EndYParamClass = class of TMODPATH_EndY;
  TMFMODPATH_EndZParamClass = class of TMODPATH_EndZ;
  TMFReferenceStressPeriodParamClass = class of TReferenceStressPeriodParam;

  TMFMNW_SiteParamClass = class of TMNW_SiteParam;
  TMFMNW_RadiusParamClass = class of TMNW_RadiusParam;
  TMFMNW_StressParamClass = class of TMNW_StressParam;
  TMFMNW_ActiveParamClass = class of TMNW_ActiveParam;
  TMFMNW_LimitingElevationParamClass = class of TMNW_LimitingElevationParam;
  TMFMNW_WaterQualityParamClass = class of TMNW_WaterQualityParam;
  TMFMNW_DrawdownFlagParamClass = class of TMNW_DrawdownFlagParam;
  TMFMNW_ReferenceElevationParamClass = class of TMNW_ReferenceElevationParam;
  TMFMNW_GroupIndentifierParamClass = class of TMNW_GroupIndentifierParam;
  TMFMNW_InactivationPumpingRateParamClass = class of TMNW_InactivationPumpingRateParam;
  TMFMNW_ReactivationPumpingRateParamClass = class of TMNW_ReactivationPumpingRateParam;
  TMFMNW_SkinParamClass = class of TMNW_SkinParam;
  TMFMNW_CoefficientParamClass = class of TMNW_CoefficientParam;
  TMFMNW_OverriddenFirstParamClass = class of TMNW_OverriddenFirstParam;
  TMFMNW_OverriddenLastParamClass = class of TMNW_OverriddenLastParam;
  TMFMNW_FirstElevationParamClass = class of TMNW_FirstElevationParam;
  TMFMNW_LastElevationParamClass = class of TMNW_LastElevationParam;
  TMFGridMNW_LocationParamClass = class of TGridMNW_Location;
  TMFMNW_FirstUnitParamClass = class of TMNW_FirstUnitParam;
  TMFMNW_LastUnitParamClass = class of TMNW_LastUnitParam;
  TMFMNW_PumpingLimitsParamClass = class of TMNW_PumpingLimitsParam;
  TMFMNW_AbsolutePumpingRatesParamClass = class of TMNW_AbsolutePumpingRatesParam;

  TMFDaflowBedElevationParamClass = class of TDaflowBedElevationParam;
  TMFDaflowBedThicknessParamClass = class of TDaflowBedThicknessParam;
  TMFDaflowBedHydraulicConductivityParamClass = class of TDaflowBedHydraulicConductivityParam;
  TMFDaflowUpstreamJunctionParamClass = class of TDaflowUpstreamJunctionParam;
  TMFDaflowDownstreamJunctionParamClass = class of TDaflowDownstreamJunctionParam;
  TMFDaflowUpstreamFlowFractionParamClass = class of TDaflowUpstreamFlowFractionParam;
  TMFDaflowInitialFlowParamClass = class of TDaflowInitialFlowParam;
  TMFDaflowTortuosityParamClass = class of TDaflowTortuosityParam;
  TMFDaflowA0ParamClass = class of TDaflowA0Param;
  TMFDaflowA1ParamClass = class of TDaflowA1Param;
  TMFDaflowA2ParamClass = class of TDaflowA2Param;
  TMFDaflowBedSlopeParamClass = class of TDaflowBedSlopeParam;
  TMFDaflowW1ParamClass = class of TDaflowW1Param;
  TMFDaflowW2ParamClass = class of TDaflowW2Param;
  TMFDaflowPrintParamClass = class of TDaflowPrintParam;
  TMFDaflowBoundaryFlowParamClass = class of TDaflowBoundaryFlowParam;
  TMFDaflowOverridenBedElevationParamClass = class of TDaflowOverridenBedElevationParam;
  TMFDaflowOverridenInitialFlowParamClass = class of TDaflowOverridenInitialFlowParam;
  TMFDaflowIsNewBoundaryParamClass = class of TDaflowIsNewBoundaryParam;
  TMFObjectObservationNameParamClass = class of TObjectObservationNameParam;
  TMFHUF_ReferenceSurfaceParamClass = class of THUF_ReferenceSurfaceParameter;

  TMFElasticStorageCoefficientParamClass = class of TElasticStorageCoefficientParam;
  TMFInelasticStorageCoefficientParamClass = class of TInelasticStorageCoefficientParam;

  TMFStartingHeadParamClass = class of TStartingHeadParam;
  TMFVerticalHydraulicConductivityParamClass = class of TVerticalHydraulicConductivityParam;
  TMFEquivalentThicknessParamClass = class of TEquivalentThicknessParam;
  TMFEquivalentNumberParamClass = class of TEquivalentNumberParam;

  TMFElasticSpecificStorageParamClass = class of TElasticSpecificStorageParam;
  TMFInelasticSpecificStorageParamClass = class of TInelasticSpecificStorageParam;
  TMFStreamGageOutputTypeParamClass = class of TStreamGageOutputTypeParam;

  TMFSKStreamUpWidthTypeParamClass = class of TMFSKStreamUpWidthParam;

  TMFDrainConductanceParamClass = class of TDrainConductanceParam;
  TMFDrainReturnConductanceParamClass = class of TDrainReturnConductanceParam;
  TMFGhbConductanceParamClass = class of TGhbConductanceParam;
  TMFRiverConductanceParamClass = class of TRiverConductanceParam;
  TMFFluidDensityParamClass = class of TFluidDensityParam;
  TMFBoundaryDensityParamClass = class of TBoundaryDensityParam;
  TMFDrainBottomElevParamClass = class of TDrainBottomElevParam;
  TMFRiverBedThicknessParamClass = class of TRiverBedThicknessParam;
  TMFLayerCountParamClass = class of TLayerCountParam;
  TMFRowCountParamClass = class of TRowCountParam;
  TMFColumnCountParamClass = class of TColumnCountParam;

  TMFGridMOCParticleLayerCountParamClass = class of TGridMOCParticleLayerCount;
  TMFGridMOCParticleRowCountParamClass = class of TGridMOCParticleRowCount;
  TMFGridMOCParticleColumnCountParamClass = class of TGridMOCParticleColumnCount;
  TMFGridMocParticleLocationParamClass = class of TGridMocParticleLocation;
  TMFUpperBoundaryConcentrationParamClass = class of TUpperBoundaryConcentrationParam;
  TMFLowerBoundaryConcentrationParamClass = class of TLowerBoundaryConcentrationParam;
  TMFGridGwtUppBoundConcParamClass = class of TGridGwtUppBoundConc;
  TMFGridGwtLowBoundConcParamClass = class of TGridGwtLowBoundConc;
  TMFFluxVariableNameParamClass = class of TFluxVariableName;
  TMFFluxTypeParamClass = class of TFluxType;
  TMFFluxStatParamClass = class of TFluxStat;
  TMFFluxVariableRatioParamClass = class of TFluxVariableRatio;
  TMFGWM_UseInPeriodParamClass = class of TGWM_UseInPeriod;
  TMFHeadConstraintNameParamClass = class of THeadConstraintName;
  TMFHeadConstraintTypeParamClass = class of THeadConstraintType;
  TMFHeadConstraintBoundaryParamClass = class of THeadConstraintBoundary;
  TMFDrawdownConstraintNameParamClass = class of TDrawdownConstraintName;
  TMFDrawdownConstraintTypeParamClass = class of TDrawdownConstraintType;
  TMFHeadDifferenceNameParamClass = class of THeadDifferenceName;
  TMFHeadDifferenceValueParamClass = class of THeadDifferenceValue;
  TMFFirstParamClass = class of TFirst;
  TMFGradientNameParamClass = class of TGradientName;
  TMFGradientValueParamClass = class of TGradientValue;
  TMFGradientLengthParamClass = class of TGradientLength;
  TMFStreamFlowNameParamClass = class of TStreamFlowName;
  TMFStreamflowValueParamClass = class of TStreamflowValue;
  TMFStreamDepletionNameParamClass = class of TStreamDepletionName;
  TMFStreamDepletionValueParamClass = class of TStreamDepletionValue;
  TMFFluxMinimumParamClass = class of TFluxMinimum;
  TMFFluxMaximumParamClass = class of TFluxMaximum;
  TMFFluxReferenceParamClass = class of TFluxReference;
  TMFFluxBaseParamClass = class of TFluxBase;
  TMFGradientStartElevationParamClass = class of TGradientStartElevation;
  TMFGradientEndElevationParamClass = class of TGradientEndElevation;

  TMFSfr2StreambedTopElevParamClass = class of TSfr2StreambedTopElev;
  TMFSfr2StreambedThicknessParamClass = class of TSfr2StreambedThickness;
  TMFSfr2SaturatedWaterContentParamClass = class of TSfr2SaturatedWaterContent;
  TMFSfr2InitialWaterContentParamClass = class of TSfr2InitialWaterContent;
  TMFSfr2BrooksCoreyExponentParamClass = class of TSfr2BrooksCoreyExponent;
  TMFSfr2UnsatZoneHydraulicConductivityParamClass = class of TSfr2UnsatZoneHydraulicConductivity;
  TMFSfr2UpstreamSaturatedWaterContentParamClass = class of TSfr2UpstreamSaturatedWaterContent;
  TMFSfr2UpstreamInitialWaterContentParamClass = class of TSfr2UpstreamInitialWaterContent;
  TMFSfr2UpstreamBrooksCoreyExponentParamClass = class of TSfr2UpstreamBrooksCoreyExponent;
  TMFSfr2UpstreamUnsatZoneHydraulicConductivityParamClass = class of TSfr2UpstreamUnsatZoneHydraulicConductivity;
  TMFSfr2DownstreamSaturatedWaterContentParamClass = class of TSfr2DownstreamSaturatedWaterContent;
  TMFSfr2DownstreamInitialWaterContentParamClass = class of TSfr2DownstreamInitialWaterContent;
  TMFSfr2DownstreamBrooksCoreyExponentParamClass = class of TSfr2DownstreamBrooksCoreyExponent;
  TMFSfr2DownstreamUnsatZoneHydraulicConductivityParamClass = class of TSfr2DownstreamUnsatZoneHydraulicConductivity;
  TMFGageDiversionParamClass = class of TGageDiversionParam;
  TMFUnsatGageParamClass = class of TUnsatGageParam;
  TMFUnsatProfileGageParamClass = class of TUnsatProfileGageParam;
  TMFMoc3dParticleObsParamClass = class of TMoc3dParticleObsParam;
  TMFGridMocParticleObservationParamClass = class of TGridMocParticleObservation;
  TMFMNW_OutputFlagParamClass = class of TMNW_OutputFlag;
  TMFLateralBoundaryConcentrationParamClass = class of TLateralBoundaryConcentrationParam;
  TMFGridGwtLateralBoundConcParamClass = class of TGridGwtLateralBoundConc;
  TMFUpperMpathElevationParamClass = class of TUpperMpathElevation;
  TMFLowerMpathElevationParamClass = class of TLowerMpathElevation;
  TMFMNW_IsPTOB_ObservationParamClass = class of TMNW_IsPTOB_Observation;

  TMFUzfSaturatedKzParamClass = class of TUzfSaturatedKz;
  TMFUzfBrooksCoreyEpsilonParamClass = class of TUzfBrooksCoreyEpsilon;
  TMFUzfSaturatedWaterContentParamClass = class of TUzfSaturatedWaterContent;
  TMFUzfInitialWaterContentParamClass = class of TUzfInitialWaterContent;
  TMFUzfExtinctionDepthParamClass = class of TUzfExtinctionDepth;
  TMFUzfExtinctionWaterContentParamClass = class of TUzfExtinctionWaterContent;
  TMFUzfInfiltrationRateParamClass = class of TUzfInfiltrationRate;
  TMFUzfPotentialEvapotranspirationParamClass = class of TUzfPotentialEvapotranspiration;
  TMFUzfLayerParamClass = class of TUzfLayerParam;
  TMFUzfStreamLakeParamClass = class of TUzfStreamLakeParam;
  TMFUzfOutputParamClass = class of TUzfOutputParam;

  TMFGridUzfSaturatedKzParamClass = class of TGridUzfSaturatedKz;
  TMFGridUzfBrooksCoreyEpsilonParamClass = class of TGridUzfBrooksCoreyEpsilon;
  TMFGridUzfSaturatedWaterContentParamClass = class of TGridUzfSaturatedWaterContent;
  TMFGridUzfInitialWaterContentParamClass = class of TGridUzfInitialWaterContent;
  TMFGridUzfExtinctionDepthParamClass = class of TGridUzfExtinctionDepth;
  TMFGridUzfExtinctionWaterContentParamClass = class of TGridUzfExtinctionWaterContent;
  TMFGridUzfModflowLayerParamClass = class of TGridUzfModflowLayerParam;
  TMFGridUzfDownstreamStreamOrLakeParamClass = class of TGridUzfDownstreamStreamOrLake;
  TMFGridUzfOutputChoiceParamClass = class of TGridUzfOutputChoice;

  TMFGeostaticStressParamClass = class of TGeostaticStressParam;
  TMFUnsaturatedSpecificGravityParamClass = class of TUnsaturatedSpecificGravityParam;
  TMFSaturatedSpecificGravityParamClass = class of TSaturatedSpecificGravityParam;

  TMFSwtThicknessParamClass = class of TSwtThicknessParam;
  TMFInitialElasticSpecificStorageParamClass = class of TInitialElasticSpecificStorageParam;
  TMFInitialInelasticSpecificStorageParamClass = class of TInitialInelasticSpecificStorageParam;
  TMFCompressionIndexParamClass = class of TCompressionIndexParam;
  TMFRecompressionIndexParamClass = class of TRecompressionIndexParam;
  TMFInitialVoidRatioParamClass = class of TInitialVoidRatioParam;
  TMFInitialCompactionParamClass = class of TInitialCompactionParam;
  TMFInitialEffectiveStressOffsetParamClass = class of TInitialEffectiveStressOffsetParam;
  TMFInitialPreconsolidationStressParamClass = class of TInitialPreconsolidationStressParam;

  TMFConcObsParamClass = class of TConcObsParam;
  TMFSpeciesParamClass = class of TSpeciesParam;
  TMFConcWeightParamClass = class of TConcWeightParam;
  TMFObservationWeightParamClass = class of TObservationWeightParam;
  TMFViscosityParamClass = class of TViscosityParam;

  TMFChdFluidDensityParamClass = class of TChdFluidDensity;
  TMFSeawatDensityOptionParamClass = class of TSeawatDensityOption;

  TMF_MNW2_WellIdParamClass = class of TMNW2_WellIdParam;
  TMF_MNW2_NodeCountParamClass = class of TMNW2_NodeCountParam;
  TMF_MNW2_LossTypeParamClass = class of TMNW2_LossTypeParam;
  TMF_MNW2_WellRadiusParamClass = class of TMNW2_WellRadiusParam;
  TMF_MNW2_SkinRadiusParamClass = class of TMNW2_SkinRadiusParam;
  TMF_MNW2_SkinKParamClass = class of TMNW2_SkinKParam;
  TMF_MNW2_BParamClass = class of TMNW2_BParam;
  TMF_MNW2_CParamClass = class of TMNW2_CParam;
  TMF_MNW2_PParamClass = class of TMNW2_PParam;
  TMF_MNW2_CellToWellConductanceParamClass = class of TMNW2_CellToWellConductanceParam;
  TMF_MNW2_SpecifyPumpParamClass = class of TMNW2_SpecifyPumpParam;
  TMF_MNW2_ConstrainPumpingParamClass = class of TMNW2_ConstrainPumpingParam;
  TMF_MNW2_PartialPenetrationFlagParamClass = class of TMNW2_PartialPenetrationFlagParam;
  TMF_MNW2_PumpTypeParamClass = class of TMNW2_PumpTypeParam;
  TMF_MNW2_PumpElevationParamClass = class of TMNW2_PumpElevationParam;
  TMF_MNW2_PumpingLimitTypeParamClass = class of TMNW2_PumpingLimitTypeParam;
  TMF_MNW2_LimitingWaterLevelParamClass = class of TMNW2_LimitingWaterLevelParam;
  TMF_MNW2_InactivationPumpingRateParamClass = class of TMNW2_InactivationPumpingRateParam;
  TMF_MNW2_ReactivationPumpingRateParamClass = class of TMNW2_ReactivationPumpingRateParam;
  TMF_MNW2_DischargeElevationParamClass = class of TMNW2_DischargeElevationParam;
  TMF_MNW2_TopWellScreenParamClass = class of TMNW2_TopWellScreenParam;
  TMF_MNW2_BottomWellScreenParamClass = class of TMNW2_BottomWellScreenParam;
  TMF_MNW2_ActiveClass = class of TMNW2_ActiveParam;
  TMF_MNW2_PumpingRateParamClass = class of TMNW2_PumpingRateParam;
  TMF_MNW2_HeadCapacityMultiplierParamClass = class of TMNW2_HeadCapacityMultiplierParam;

  TMF_MNW2_OrderParamClass = class of TMNW2_OrderParam;
  TMF_MNW2_UpperElevParamClass = class of TMNW2_UpperElevParam;
  TMF_MNW2_LowerElevParamClass = class of TMNW2_LowerElevParam;

  TMF_MNW2_MonitorWellParamClass = class of TMonitorWellFlowParam;
  TMF_MNW2_MonitorExternalFlowParamClass = class of TMonitorExternalFlowParam;
  TMF_MNW2_MonitorInternalFlowParamClass = class of TMonitorInternalFlowParam;
  TMF_MNW2_MonitorConcentrationParamClass = class of TMonitorConcentrationParam;

  TMF_GwmNameParamClass = class of TGwmNameParam;
  TMF_GwmElevationParamClass = class of TGwmElevationParam;
  TMF_GwmSegmentParamClass = class of TGwmSegmentParam;
  TMF_GwmZoneNumberParamClass = class of TGwmZoneNumberParam;
  TMF_GwmStressPeriodParamClass = class of TGwmStressPeriodParam;

  TMF_GridGwmZoneParamClass = class of TGridGwmZone;

implementation



end.
